////////////////////////////////////////////////////////////////////////////////
//
//  ****************************************************************************
//  * Unit Name : GrdEnumDonges
//  * Purpose   :      Guardant
//  * Author    :  (Rouse_) 
//  * Copyright :  Fangorn Wizards Lab 1998 - 2012.
//  * Version   : 1.0
//  * Home Page : http://rouse.drkb.ru
//  * Home Blog : http://alexander-bagel.blogspot.com/
//  ****************************************************************************
//

unit GrdEnumDonges;

interface

uses
  Windows,
  Classes,
  SysUtils;

const
  ntdll = 'ntdll.dll';
  cfgmgr = 'cfgmgr32.dll';

  ANYSIZE_ARRAY = 1024;

  GUID_DEVINTERFACE_DISK: TGUID = (
    D1:$53f56307; D2:$b6bf; D3:$11d0; D4:($94, $f2, $00, $a0, $c9, $1e, $fb, $8b));

  DIGCF_PRESENT         = $00000002;
  DIGCF_DEVICEINTERFACE = $00000010;

  FILE_DEVICE_CONTROLLER = $00000004;
  FILE_DEVICE_FILE_SYSTEM = $00000009;
  FILE_DEVICE_MASS_STORAGE = $0000002D;

  METHOD_BUFFERED = $00000000;
  FILE_ANY_ACCESS = $00000000;
  FILE_READ_ACCESS = $00000001;
  FILE_WRITE_ACCESS = $00000002;

  IOCTL_STORAGE_BASE = FILE_DEVICE_MASS_STORAGE;
  IOCTL_SCSI_BASE = FILE_DEVICE_CONTROLLER;

  IOCTL_STORAGE_GET_DEVICE_NUMBER = (IOCTL_STORAGE_BASE shl 16) or
    (FILE_ANY_ACCESS shl 14) or ($0420 shl 2) or METHOD_BUFFERED;

  ObjectNameInformation = 1;

  DIGCF_ALLCLASSES = $00000004;
  DIGCF_PROFILE = $00000008;
  SPDRP_DEVICEDESC = $00000000;
  SPDRP_PHYSICAL_DEVICE_OBJECT_NAME = $0000000E;
  OBJ_CASE_INSENSITIVE = $00000040;
  STATUS_SUCCESS = 0;
  FILE_SYNCHRONOUS_IO_NONALERT = $00000020;
  FILE_READ_DATA = 1;

type
  EEnumDonglesEx = class(Exception);

  ULONG_PTR = DWORD;

  PSPDevInfoData = ^TSPDevInfoData;
  SP_DEVINFO_DATA = record
    cbSize: DWord;
    ClassGuid: TGuid;
    DevInst: DWord; // DEVINST handle
    Reserved: LongInt;
  end;
  PSP_DEVINFO_DATA = ^SP_DEVINFO_DATA;
  TSPDevInfoData = SP_DEVINFO_DATA;

  PGuid = ^TGuid;
  H_DEV = Pointer;
  DEVINST = DWORD;
  CONFIGRET = DWORD;
  HDEVINFO = DWORD;

  PSPDeviceInterfaceData = ^TSPDeviceInterfaceData;
  SP_DEVICE_INTERFACE_DATA = packed record
    cbSize: DWORD;
    InterfaceClassGuid: TGUID;
    Flags: DWORD;
    Reserved: ULONG_PTR;
  end;
  TSPDeviceInterfaceData = SP_DEVICE_INTERFACE_DATA;

  PSPDeviceInterfaceDetailDataA = ^TSPDeviceInterfaceDetailDataA;
  PSPDeviceInterfaceDetailData = PSPDeviceInterfaceDetailDataA;
  SP_DEVICE_INTERFACE_DETAIL_DATA_A = packed record
    cbSize: DWORD;
    DevicePath: array [0..ANYSIZE_ARRAY - 1] of AnsiChar;
  end;
  TSPDeviceInterfaceDetailDataA = SP_DEVICE_INTERFACE_DETAIL_DATA_A;
  TSPDeviceInterfaceDetailData = TSPDeviceInterfaceDetailDataA;

  TSetupDiGetClassDevsA = function(ClassGuid: PGuid; Enumerator: PAnsiChar;
    hwndParent: DWORD; Flags: DWORD): Pointer; stdcall;
  TSetupDiGetDeviceRegistryPropertyA = function(DeviceInfoSet: Pointer;
    DeviceInfoData: PSP_DEVINFO_DATA; Property_: DWord;
    PropertyRegDataType: Pointer; PropertyBuffer: Pointer;
    PropertyBufferSize: DWord; RequiredSize: Pointer): longbool; stdcall;
  TSetupDiEnumDeviceInfo = function(DeviceInfoSet: Pointer; MemberIndex: DWord;
    var DeviceInfoData: SP_DEVINFO_DATA): longbool; stdcall;
  TSetupDiDestroyDeviceInfoList = function(DeviceInfoSet: Pointer): longbool;
    stdcall;
  TSetupDiEnumDeviceInterfaces = function(DeviceInfoSet: HDEVINFO;
    DeviceInfoData: PSPDevInfoData; const InterfaceClassGuid: TGUID;
    MemberIndex: DWORD; var DeviceInterfaceData: TSPDeviceInterfaceData):
    LongBool; stdcall;
  TSetupDiGetDeviceInterfaceDetailA = function(DeviceInfoSet: HDEVINFO;
    DeviceInterfaceData: PSPDeviceInterfaceData;
    DeviceInterfaceDetailData: PSPDeviceInterfaceDetailDataA;
    DeviceInterfaceDetailDataSize: DWORD; var RequiredSize: DWORD;
    Device: PSPDevInfoData): LongBool; stdcall;

  UNICODE_STRING = record
    Length: WORD;
    MaximumLength: WORD;
    Buffer: PWideChar;
  end;

  PUNICODE_STRING = ^UNICODE_STRING;

  TUNICODE_STRING = packed record
    Length : WORD;
    MaximumLength : WORD;
    Buffer : array [0..MAX_PATH - 1] of WideChar;
  end;

  POBJECT_NAME_INFORMATION = ^TOBJECT_NAME_INFORMATION;
  TOBJECT_NAME_INFORMATION = packed record
    Name : TUNICODE_STRING;
  end;

  OBJECT_ATTRIBUTES = record
    Length: ULONG;
    RootDirectory: THandle;
    ObjectName: PUNICODE_STRING;
    Attributes: ULONG;
    SecurityDescriptor: Pointer;
    SecurityQualityOfService: Pointer;
  end;

  POBJECT_ATTRIBUTES = ^OBJECT_ATTRIBUTES;

  IO_STATUS_BLOCK = record
    case integer of
      0:
        (Status: DWord);
      1:
        (Pointer: Pointer;
          Information: ULONG);
  end;

  PIO_STATUS_BLOCK = ^IO_STATUS_BLOCK;

  TDongleQueryRecord = packed record
    dwPublicCode: DWord; // Public code
    byHrwVersion: Byte; //   
    byMaxNetRes: Byte; //   
    wType: WORD; //   
    dwID: DWord; // ID 
    byNProg: Byte; //  
    byVer: Byte; // 
    wSN: WORD; //  
    wMask: WORD; //  
    wGP: WORD; //   GP/ 
    wRealNetRes: WORD; //   , .. <= byMaxNetRes
    dwIndex: DWord; //    
  end;

  TDongleQueryRecordWsPath = record
    Data: TDongleQueryRecord;
    PnPParentPath: string;
  end;

  TDongleQueryRecordEx = packed record
    Unknown0: array [0..341] of Byte;
    wMask: WORD;    //  
    wSN: WORD;      //  
    byVer: Byte;    // 
    byNProg: Byte;  //  
    dwID: DWORD;    // ID 
    wType: WORD;    //   
    Unknown1: array [354..355] of Byte;
    dwPublicCode: DWORD;
    Unknown2: array [360..375] of Byte;
    dwHrwVersion: DWORD; //  
    dwProgNumber: DWORD; //  
    Unknown3: array [384..511] of Byte;
  end;

  TUSBDevice = record
    _Label: Char;
    DiskNumber: DWORD;
    Link: string;
    DeviceName: string;
    FoundGuardant: Boolean;
  end;
  TUSBDevices = array of TUSBDevice;

  DEVICE_TYPE = DWORD;

  PStorageDeviceNumber = ^TStorageDeviceNumber;
  TStorageDeviceNumber = packed record
    DeviceType: DEVICE_TYPE;
    DeviceNumber: DWORD;
    PartitionNumber: DWORD;
  end;

  TEnumDonglesEx = class
  private
    FDongles: array of TDongleQueryRecordWsPath;
    hLib: THandle;
    SetupDiGetClassDevsA: TSetupDiGetClassDevsA;
    SetupDiGetDeviceRegistryPropertyA: TSetupDiGetDeviceRegistryPropertyA;
    SetupDiEnumDeviceInfo: TSetupDiEnumDeviceInfo;
    SetupDiDestroyDeviceInfoList: TSetupDiDestroyDeviceInfoList;
    SetupDiEnumDeviceInterfaces: TSetupDiEnumDeviceInterfaces;
    SetupDiGetDeviceInterfaceDetailA: TSetupDiGetDeviceInterfaceDetailA;
    FGuardantFlashDrives: TStringList;
    function GetCount: Integer;
    function GetItem(Index: Integer): TDongleQueryRecordWsPath;
  protected
    function InitSetupAPI: Boolean;
    procedure UpdateUSBDevices;
  public
    constructor Create;
    destructor Destroy; override;
    procedure Update;
    property Count: Integer read GetCount;
    property Item[Index: Integer]: TDongleQueryRecordWsPath read GetItem; default;
    property GuardantFlashDrives: TStringList read FGuardantFlashDrives;
  end;

  function ZwClose(AHandle: THandle): DWord; stdcall; external ntdll;

  function ZwOpenFile(FileHandle: PHANDLE; DesiredAccess: ACCESS_MASK;
    ObjectAttributes: POBJECT_ATTRIBUTES; IoStatusBlock: PIO_STATUS_BLOCK;
    ShareAccess: ULONG; OpenOptions: ULONG): DWord; stdcall; external ntdll;

  procedure RtlInitUnicodeString(DestinationString: PUNICODE_STRING;
    SourceString: LPCWSTR); stdcall; external ntdll;

  function CM_Get_Parent(var dnDevInstParent: DEVINST;
    dnDevInst: DEVINST; ulFlags: ULONG): CONFIGRET; stdcall;
    external cfgmgr;

  function CM_Get_DevNode_Registry_PropertyA(
    dnDevInst: DEVINST; ulProperty: ULONG; pulRegDataType: PULONG;
    Buffer: Pointer; pulLength: PULONG; ulFlags: ULONG): CONFIGRET; stdcall;
    external cfgmgr;

  function NtQueryObject(ObjectHandle: THandle;
    ObjectInformationClass: DWORD; ObjectInformation: Pointer;
    ObjectInformationLength: ULONG;
    ReturnLength: PDWORD): DWORD; stdcall; external ntdll;


implementation

uses
  RTLConsts;

const
  FlashBuffer: array [0..511] of Byte = (
    $53, $33, $53, $54, $20, $47, $52, $44, $00, $00, $00, $00, $00, $00,
    $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $01, $00, $00,
    $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00,
    $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00,
    $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00,
    $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00,
    $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00,
    $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00,
    $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00,
    $00, $00, $00, $01, $00, $00, $00, $00, $00, $00, $00, $01, $00, $00,
    $00, $00, $00, $00, $00, $01, $00, $00, $00, $00, $00, $00, $00, $00,
    $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00,
    $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00,
    $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00,
    $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00,
    $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00,
    $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00,
    $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00,
    $00, $00, $00, $00, $2F, $01, $04, $01, $72, $07, $CC, $46, $2C, $55,
    $B7, $D2, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00,
    $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00,
    $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $FA, $00, $4C, $00,
    $00, $00, $4C, $00, $00, $00, $00, $00, $F6, $E8, $57, $5A, $2F, $01,
    $04, $02, $00, $00, $CC, $46, $2C, $55, $B7, $D2, $00, $00, $00, $00,
    $CC, $DA, $D0, $C7, $21, $AC, $84, $74, $84, $39, $D0, $9E, $00, $00,
    $00, $00, $00, $00, $00, $00, $01, $00, $00, $01, $22, $00, $00, $00,
    $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00,
    $00, $00, $00, $00, $00, $00, $2F, $01, $04, $03, $00, $00, $CC, $46,
    $2C, $55, $B7, $D2, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00,
    $00, $00, $00, $00, $00, $00, $00, $00, $AE, $2C, $08, $40, $00, $00,
    $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00,
    $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00,
    $2F, $01, $04, $04, $00, $00, $CC, $46, $2C, $55, $B7, $D2, $00, $00,
    $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00,
    $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00,
    $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00,
    $00, $00, $00, $00, $00, $00, $00, $00);

  GrdGUID: TGUID = '{C29CC2E3-BC48-4B74-9043-2C6413FFA784}';

  GetDongleQueryRecordIOCTL = $E1B20008;
  GetDongleQueryRecordExIOCTL = $E1B20018;

{ TEnumDonglesEx }

constructor TEnumDonglesEx.Create;
begin
  FGuardantFlashDrives := TStringList.Create;
end;

destructor TEnumDonglesEx.Destroy;
begin
  FGuardantFlashDrives.Free;
  inherited;
end;

function TEnumDonglesEx.GetCount: integer;
begin
  Result := Length(FDongles);
end;

function TEnumDonglesEx.GetItem(Index: integer): TDongleQueryRecordWsPath;
begin
  if (Index < 0) or (Index >= Count) then
    raise EEnumDonglesEx.CreateFmt(SListIndexError, [Index]);
  Result := FDongles[Index];
end;

function TEnumDonglesEx.InitSetupAPI: Boolean;
begin
  Result := False;
  hLib := LoadLibrary('setupapi.dll');
  if hLib <= HINSTANCE_ERROR then
    Exit;
  try
    SetupDiGetClassDevsA := GetProcAddress(hLib, 'SetupDiGetClassDevsA');
    if not Assigned(SetupDiGetClassDevsA) then
      Abort;
    SetupDiGetDeviceRegistryPropertyA := GetProcAddress(hLib,
      'SetupDiGetDeviceRegistryPropertyA');
    if not Assigned(SetupDiGetDeviceRegistryPropertyA) then
      Abort;
    SetupDiEnumDeviceInfo := GetProcAddress(hLib, 'SetupDiEnumDeviceInfo');
    if not Assigned(SetupDiEnumDeviceInfo) then
      Abort;
    SetupDiDestroyDeviceInfoList := GetProcAddress(hLib,
      'SetupDiDestroyDeviceInfoList');
    if not Assigned(SetupDiDestroyDeviceInfoList) then
      Abort;
    SetupDiEnumDeviceInterfaces := GetProcAddress(hLib,
      'SetupDiEnumDeviceInterfaces');
    if not Assigned(SetupDiEnumDeviceInterfaces) then
      Abort;
    SetupDiGetDeviceInterfaceDetailA := GetProcAddress(hLib,
      'SetupDiGetDeviceInterfaceDetailA');
    if not Assigned(SetupDiGetDeviceInterfaceDetailA) then
      Abort;
  except
    FreeLibrary(hLib);
    Exit;
  end;
  Result := True;
end;

procedure TEnumDonglesEx.Update;

  function CompareGuid(GUID1, GUID2: TGuid): Boolean;
  begin
    Result := CompareMem(@GUID1, @GUID2, Sizeof(TGuid));
  end;

  function htons(Value: WORD): WORD;
  begin
    Result := (Value and $FF) shl 8 + (Value shr 8);
  end;

  function htonl(Value: DWORD): DWORD;
  begin
    Result :=
      (Value and $FF) shl 24 +
      (Value and $FF00) shl 8 +
      (Value and $FF0000) shr 8 +
      (Value shr 24);
  end;

  function GetPnP_ParentPath(Value: DWORD): string;
  var
    hParent: DWORD;
    Buffer: array [0..1023] of AnsiChar;
    Len: ULONG;
    S: string;
  begin
    Result := '';
    if CM_Get_Parent(hParent, Value, 0) = 0 then
    begin
      Len := Length(Buffer);
      CM_Get_DevNode_Registry_PropertyA(hParent, 15, nil,
        @Buffer[0], @Len, 0);
      S := string(PAnsiChar(@Buffer[0]));
      while CM_Get_Parent(hParent, hParent, 0) = 0 do
      begin
        Len := Length(Buffer);
        CM_Get_DevNode_Registry_PropertyA(hParent, 15, nil,
          @Buffer[0], @Len, 0);
        S := string(PAnsiChar(@Buffer[0]));
        Result := S + '#' + Result;
      end;
    end;
    if Result = '' then
      Result := ' ';
  end;

var
  dwRequired: DWord;
  hAllDevices: H_DEV;
  dwInfo: DWORD;
  Data: SP_DEVINFO_DATA;
  Buff: array [0 .. 99] of AnsiChar;
  hDeviceHandle: THandle;
  US: UNICODE_STRING;
  OA: OBJECT_ATTRIBUTES;
  IO: IO_STATUS_BLOCK;
  NTSTAT, dwReturn: DWORD;
  DongleQueryRecord: TDongleQueryRecord;
  DongleQueryRecordEx: TDongleQueryRecordEx;
begin
  SetLength(FDongles, 0);
  DWord(hAllDevices) := INVALID_HANDLE_VALUE;
  try
    if not InitSetupAPI then
      Exit;
    UpdateUSBDevices;

    hAllDevices := SetupDiGetClassDevsA(nil, nil, 0,
      DIGCF_PRESENT or DIGCF_ALLCLASSES);
    if DWord(hAllDevices) <> INVALID_HANDLE_VALUE then
    begin
      FillChar(Data, Sizeof(SP_DEVINFO_DATA), 0);
      Data.cbSize := Sizeof(SP_DEVINFO_DATA);
      dwInfo := 0;
      while SetupDiEnumDeviceInfo(hAllDevices, dwInfo, Data) do
      begin
        dwRequired := 0;
        FillChar(Buff[0], 100, #0);
        if SetupDiGetDeviceRegistryPropertyA(hAllDevices, @Data,
          SPDRP_PHYSICAL_DEVICE_OBJECT_NAME, nil, @Buff[0], 100, @dwRequired)
          then
          if CompareGuid(Data.ClassGuid, GrdGUID) then
          begin
            RtlInitUnicodeString(@US, StringToOleStr(string(Buff)));
            FillChar(OA, Sizeof(OBJECT_ATTRIBUTES), #0);
            OA.Length := Sizeof(OBJECT_ATTRIBUTES);
            OA.ObjectName := @US;
            OA.Attributes := OBJ_CASE_INSENSITIVE;
            NTSTAT := ZwOpenFile(@hDeviceHandle,
              FILE_READ_DATA or SYNCHRONIZE, @OA, @IO,
              FILE_SHARE_READ or FILE_SHARE_WRITE or FILE_SHARE_DELETE,
              FILE_SYNCHRONOUS_IO_NONALERT);
            if NTSTAT = STATUS_SUCCESS then
            try

              if DeviceIoControl(hDeviceHandle, GetDongleQueryRecordIOCTL,
                nil, 0, @DongleQueryRecord, SizeOf(TDongleQueryRecord),
                dwReturn, nil) and (DongleQueryRecord.dwID <> 0) then
              begin
                SetLength(FDongles, Count + 1);
                FDongles[Count - 1].Data := DongleQueryRecord;
                FDongles[Count - 1].PnPParentPath :=
                  GetPnP_ParentPath(Data.DevInst);
                Inc(dwInfo);
                Continue;
              end;

              Move(FlashBuffer[0], DongleQueryRecordEx.Unknown0[0], 512);

              if DeviceIoControl(hDeviceHandle, GetDongleQueryRecordExIOCTL,
                @DongleQueryRecordEx.Unknown0[0],
                SizeOf(TDongleQueryRecordEx),
                @DongleQueryRecordEx.Unknown0[0],
                SizeOf(TDongleQueryRecordEx),
                dwReturn, nil) then
              begin

                DongleQueryRecordEx.wMask :=
                  htons(DongleQueryRecordEx.wMask);
                DongleQueryRecordEx.wSN :=
                  htons(DongleQueryRecordEx.wSN);
                DongleQueryRecordEx.dwID :=
                  htonl(DongleQueryRecordEx.dwID);
                DongleQueryRecordEx.dwPublicCode :=
                  htonl(DongleQueryRecordEx.dwPublicCode);
                DongleQueryRecordEx.wType :=
                  htons(DongleQueryRecordEx.wType);

                SetLength(FDongles, Count + 1);
                ZeroMemory(@DongleQueryRecord, SizeOf(DongleQueryRecord));
                DongleQueryRecord.dwPublicCode :=
                  DongleQueryRecordEx.dwPublicCode;
                DongleQueryRecord.dwID := DongleQueryRecordEx.dwID;
                DongleQueryRecord.byNProg := DongleQueryRecordEx.byNProg;
                DongleQueryRecord.byVer := DongleQueryRecordEx.byVer;
                DongleQueryRecord.wSN := DongleQueryRecordEx.wSN;
                DongleQueryRecord.wMask := DongleQueryRecordEx.wMask;
                DongleQueryRecord.wType := DongleQueryRecordEx.wType;
                FDongles[Count - 1].Data := DongleQueryRecord;
                FDongles[Count - 1].PnPParentPath :=
                  GetPnP_ParentPath(Data.DevInst);
              end;
            finally
              ZwClose(hDeviceHandle);
            end;
          end;
        Inc(dwInfo);
      end;
    end;
  finally
    if DWord(hAllDevices) <> INVALID_HANDLE_VALUE then
      SetupDiDestroyDeviceInfoList(hAllDevices);
  end;
end;

procedure TEnumDonglesEx.UpdateUSBDevices;
const
  DriveNameSize = 4;
  VolumeCount = 26;
  DriveTotalSize = DriveNameSize * VolumeCount;
  SPDRP_HARDWAREID = 1;
var
  USBDevices: TUSBDevices;
  hFile, hDevInfo, hDrive: THandle;
  sdn: TStorageDeviceNumber;
  dwBytesReturned, dwSize: DWORD;
  FlashGuid: TGUID;
  I, A, Count, UsbCount: Integer;
  DeviceInfoData: TSPDevInfoData;
  DeviceInterfaceData: TSPDeviceInterfaceData;
  DeviceInterfaceDetailData: TSPDeviceInterfaceDetailData;
  Buff, Volume: string;
begin
  FGuardantFlashDrives.Clear;

  SetLength(Buff, DriveTotalSize);
  Count := GetLogicalDriveStrings(DriveTotalSize, @Buff[1]) div DriveNameSize;
  SetLength(USBDevices, Count);

  UsbCount := 0;

  for I := 0 to Count - 1 do
  begin
    Volume := PChar(@Buff[(I * DriveNameSize) + 1]);
    Volume[3] := #0;

    if GetDriveType(PChar(Volume)) <> DRIVE_REMOVABLE then Continue;

    //  
    Volume := '\\.\' + Volume;
    hFile := CreateFile(PChar(Volume), 0,
      FILE_SHARE_READ or FILE_SHARE_WRITE, nil, OPEN_EXISTING, 0, 0);
    if hFile = INVALID_HANDLE_VALUE then Exit;
    try
      //     
      if not DeviceIoControl(hFile,
        IOCTL_STORAGE_GET_DEVICE_NUMBER, nil, 0, @sdn,
          SizeOf(TStorageDeviceNumber), dwBytesReturned, nil) then Continue;
      USBDevices[UsbCount]._Label := Volume[5];
      USBDevices[UsbCount].DiskNumber := sdn.DeviceNumber;
      Inc(UsbCount);
    finally
      CloseHandle(hFile);
    end;
  end;
  if UsbCount = 0 then Exit;
  SetLength(USBDevices, UsbCount);

  FlashGuid := GUID_DEVINTERFACE_DISK;

  //     ,    
  hDevInfo := THandle(SetupDiGetClassDevsA(@FlashGuid, nil, 0,
    DIGCF_PRESENT or DIGCF_DEVICEINTERFACE));
  if hDevInfo = INVALID_HANDLE_VALUE then Exit;
  try

    I := 0;
    //     
    DeviceInterfaceData.cbSize := SizeOf(TSPDeviceInterfaceData);
    while SetupDiEnumDeviceInterfaces(
      hDevInfo, nil, FlashGuid, I, DeviceInterfaceData) do
    begin

      Inc(I);

      //         
      SetupDiGetDeviceInterfaceDetailA(hDevInfo, @DeviceInterfaceData,
        nil, 0, dwSize, nil);
      if dwSize = 0 then Exit;

      DeviceInfoData.cbSize :=  SizeOf(TSPDevInfoData);

      //  ,       .
      // ?    ,       -
      //     SetupDiGetDeviceInterfaceDetailA
      //   
      DeviceInterfaceDetailData.cbSize := 5;

      //    
      if not SetupDiGetDeviceInterfaceDetailA(hDevInfo, @DeviceInterfaceData,
        @DeviceInterfaceDetailData, dwSize, dwSize, @DeviceInfoData) then Exit;

      //  
      hDrive := CreateFileA(PAnsiChar(@DeviceInterfaceDetailData.DevicePath[0]),
        0, FILE_SHARE_READ or FILE_SHARE_WRITE, nil, OPEN_EXISTING, 0, 0);
      if hDrive = INVALID_HANDLE_VALUE then Exit;
      try

        //     
        if not DeviceIoControl(hDrive,
          IOCTL_STORAGE_GET_DEVICE_NUMBER, nil, 0, @sdn,
            SizeOf(TStorageDeviceNumber), dwBytesReturned, nil) then Exit;

        for A := 0 to UsbCount - 1 do
          if USBDevices[A].DiskNumber = sdn.DeviceNumber then
            if Pos('ven_guardant', LowerCase(string(
              PAnsiChar(@DeviceInterfaceDetailData.DevicePath[0])))) > 0 then
              FGuardantFlashDrives.Add(USBDevices[A]._Label);

      finally
        CloseHandle(hDrive);
      end;
    end;
  finally
    SetupDiDestroyDeviceInfoList(Pointer(hDevInfo));
  end;
end;

end.
